"""
Django settings for TaskITAPI project.

Generated by 'django-admin startproject' using Django 2.2.

For more information on this file, see
https://docs.djangoproject.com/en/2.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/2.2/ref/settings/
"""

import os 

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/2.2/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'eq5w+duj7xe&#)vt$%*+kcwv72iooq+6&uv9h6@+&38oor$yj@'

# SECURITY WARNING: don't run with debug turned on in production!
if (('APP_ENV' in os.environ) and os.environ['APP_ENV'] == 'dev'):
    from .dev import *
elif (('APP_ENV' in os.environ) and os.environ['APP_ENV'] == 'qa'):
    from .qa import *    
else : 
    from .default import *

SILENCED_SYSTEM_CHECKS = ['auth.E003', 'auth.W004']

ALLOWED_HOSTS = ["127.0.0.1","192.168.3.11","192.168.3.221","sw_apps.benchmarksolution.com","49.248.119.130","bcspl360.xyz","35.165.213.177"]
# #,"sw_apps.benchmarksolution.com","49.248.119.130","*",".benchmarksolution.com"*#

DEFAULT_LANGUAGE = 'en-US'
DEFAULT_CURRENCY = 'INR'
DEFAULT_PASSWORD = 'Taskit@123'

# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    #---Third--
    'rest_framework',
    'drf_yasg',
    'debug_toolbar',
    'soft_delete_it',
    'corsheaders', 
    'paywix',   
    # ---Apps--
    'accounts',
    'social_auth',
    'configs',
    'jwtauth',
    'settings',
    'notifications',
    'masters',
    'gigs',
    'sellers',
    'orders',
    '_requests',
    'payments'
]


MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.locale.LocaleMiddleware',
    'corsheaders.middleware.CorsMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',    
    # -----
    'debug_toolbar.middleware.DebugToolbarMiddleware',
    'TaskITAPI.middleware.ExceptionLogMiddleware',
]

if ENCRYPT == True :
    MIDDLEWARE.append(
        'TaskITAPI.middleware.EncryptionMiddleware'
    )

ROOT_URLCONF = 'TaskITAPI.urls'


TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'TaskITAPI.wsgi.application'

# Password validation
# https://docs.djangoproject.com/en/2.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]



# Internationalization
# https://docs.djangoproject.com/en/2.2/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'Asia/Kolkata'

USE_I18N = True

USE_L10N = True

USE_TZ = False

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/2.2/howto/static-files/

# MEDIA_URL = '/media/'
# STATIC_URL = '/static/'
STATIC_ROOT = os.path.join(BASE_DIR,'static/')
MEDIA_ROOT =  os.path.join(BASE_DIR, 'media').replace('\\', '/') 
MEDIA_URL = '/media/'
STATIC_URL = '/backend/static/'


# Rest Framework
REST_FRAMEWORK = {
    'DEFAULT_AUTHENTICATION_CLASSES': [
        'jwtauth.authentication.JWTAuthentication',
        'TaskITAPI.sessions.CustomSessionAuthentication',        
    ],
    'DEFAULT_SCHEMA_CLASS': 'rest_framework.schemas.coreapi.AutoSchema',
    'DEFAULT_PERMISSION_CLASSES': [
        'rest_framework.permissions.IsAuthenticated'
    ],
    'EXCEPTION_HANDLER': 'TaskITAPI.exceptions.api_exception_handler'
}

AUTH_USER_MODEL = 'accounts.User'

SWAGGER_SETTINGS = {
    'DOC_EXPANSION': 'none',
    "DEFAULT_MODEL_RENDERING": 'example',
    'LOGOUT_URL': '/accounts/logout/',
    'DEFAULT_AUTO_SCHEMA_CLASS':'TaskITAPI.swagger.generators.ReadWriteAutoSchema'
}

CORS_ORIGIN_ALLOW_ALL = True
CORS_ALLOW_CREDENTIALS = True

INTERNAL_IPS = [
    '127.0.0.1',
]

EMAIL_USE_TLS = True

from celery.schedules import crontab

CELERY_BEAT_SCHEDULE = {
    # "scheduled-task": {
    # "task": "notifications.tasks.scheduled_notifications",
    # # 'schedule': crontab(hour='*/4'),
    # 'schedule': crontab(),
    # "args": (),
    # },
    "approved-request-to-seller-scheduled-task": {
    "task": "notifications.tasks.approved_request_to_seller_scheduled_notifications",
    'schedule': crontab(hour='*/4'),
    # 'schedule': crontab(),
    "args": (),
    }
}

SYS_ADMIN_USER_ID = 1
DEFAULT_PAGE_SIZE = 20

VERIFICATION_LINK_EXPIRE_DAYS = 1

# Celery Configuration Options
CELERY_ENABLE_UTC = False
CELERY_TIMEZONE = 'Asia/Kolkata'

